unit EntitiesUnit;

interface

uses
  SysUtils, 
  Generics.Collections, 
  Aurelius.Mapping.Attributes, 
  Aurelius.Types.Blob, 
  Aurelius.Types.DynamicProperties, 
  Aurelius.Types.Nullable, 
  Aurelius.Types.Proxy;

type
  TTRX_DEP = class;
  
  [Entity]
  [Table('TRX_DEP')]
  [Sequence('GEN_TRX_DEP_ID')]
  [Id('FID', TIdGenerator.IdentityOrSequence)]
  TTRX_DEP = class
  private
    [Column('ID', [TColumnProp.Required])]
    FID: Integer;
    
    [Column('PRICE_VAL', [TColumnProp.Required])]
    FPRICE_VAL: Double;
    
    [Column('DATE_TRX', [TColumnProp.Required])]
    FDATE_TRX: TDateTime;
    
    [Column('EMAIL', [TColumnProp.Required], 60)]
    FEMAIL: string;
    
    [Column('DESCRIPTION', [], 100)]
    FDESCRIPTION: Nullable<string>;
    
    [Column('CHANNEL', [], 10)]
    FCHANNEL: Nullable<string>;
    
    [Column('ID_TRX_CORRECTION', [])]
    FID_TRX_CORRECTION: Nullable<Integer>;
  public
    property ID: Integer read FID write FID;
    property PRICE_VAL: Double read FPRICE_VAL write FPRICE_VAL;
    property DATE_TRX: TDateTime read FDATE_TRX write FDATE_TRX;
    property EMAIL: string read FEMAIL write FEMAIL;
    property DESCRIPTION: Nullable<string> read FDESCRIPTION write FDESCRIPTION;
    property CHANNEL: Nullable<string> read FCHANNEL write FCHANNEL;
    property ID_TRX_CORRECTION: Nullable<Integer> read FID_TRX_CORRECTION write FID_TRX_CORRECTION;
  end;
  

implementation

initialization
  RegisterEntity(TTRX_DEP);

finalization

end.
