unit ReplicateServiceImplementation;

interface

uses
  System.DateUtils,
  System.SysUtils,
  System.Generics.Collections,
  XData.Server.Module,
  XData.Service.Common,
  ReplicateService;

type
  [ServiceImplementation]
  TReplicateService = class(TInterfacedObject, IReplicateService)
  private
    function correction(Id: Integer): string;
  end;

implementation

uses
  EntitiesUnit,
  XData.Sys.Exceptions, XData.Client,
  Aurelius.Engine.ObjectManager, Sparkle.Security,
  XData.Aurelius.Model, Aurelius.Linq,
  Aurelius.Mapping.Explorer, Aurelius.Criteria.Projections;

{ TReplicateService }

function TReplicateService.correction(Id: Integer): string;
var
  Manager: TObjectManager;
  TrxDep: TTRX_DEP;
  TrxDepList: TList<TTRX_DEP>;
  dValue: Double;
begin
  Manager := TXDataOperationContext.Current.CreateManager(TMappingExplorer.Default);
  TrxDepList := Manager.Find<TTRX_DEP>
                        .Where((Linq['ID'] = Id))
                        .List;
  TXDataOperationContext.Current.Handler.ManagedObjects.Add(TrxDepList);
  if TrxDepList.Count = 0 then
     raise EXDataHttpException.Create(403, 'data not found');

  dValue := TrxDepList[0].PRICE_VAL;
  TrxDep := TTRX_DEP.Create;
  TrxDep.PRICE_VAL := -dValue;
  TrxDep.DATE_TRX := Now;
  TrxDep.EMAIL := TrxDepList[0].EMAIL;
  TrxDep.DESCRIPTION := TrxDepList[0].DESCRIPTION;
  TrxDep.CHANNEL := TrxDepList[0].CHANNEL;
  TrxDep.ID_TRX_CORRECTION := TrxDepList[0].ID;
  Manager.Save(TrxDep);
end;

initialization
  RegisterServiceType(TReplicateService);

end.
