unit uServerContainer;

interface

uses
  System.SysUtils, System.Classes, Sparkle.HttpServer.Module,
  Sparkle.HttpServer.Context, Sparkle.Comp.Server,
  Sparkle.Comp.HttpSysDispatcher, Aurelius.Drivers.Interfaces,
  Aurelius.Comp.Connection, XData.Comp.ConnectionPool, XData.Server.Module,
  XData.Comp.Server, Aurelius.Sql.Firebird, Aurelius.Schema.Firebird,
  Aurelius.Drivers.FireDac, FireDAC.Stan.Intf, FireDAC.Stan.Option,
  FireDAC.Stan.Error, FireDAC.UI.Intf, FireDAC.Phys.Intf, FireDAC.Stan.Def,
  FireDAC.Stan.Pool, FireDAC.Stan.Async, FireDAC.Phys, FireDAC.Phys.FB,
  FireDAC.Phys.FBDef, FireDAC.VCLUI.Wait, Data.DB, FireDAC.Comp.Client,
  Sparkle.Comp.GenericMiddleware, Sparkle.Comp.JwtMiddleware,
  Sparkle.Comp.BasicAuthMiddleware, Sparkle.Comp.LoggingMiddleware,
  Sparkle.Comp.CompressMiddleware, Sparkle.Comp.CorsMiddleware,
  Bcl.TMSLogging, TMSLoggingTextOutputHandler, Bcl.Logging, TMSLoggingCore;

type
  TServerContainer = class(TDataModule)
    SparkleHttpSysDispatcher: TSparkleHttpSysDispatcher;
    XDataApi: TXDataServer;
    XDataPoolApi: TXDataConnectionPool;
    AureliusApi: TAureliusConnection;
    FDApi: TFDConnection;
    XDataApiCompress: TSparkleCompressMiddleware;
    XDataApiLoggingError: TSparkleLoggingMiddleware;
    procedure DataModuleCreate(Sender: TObject);
  end;

var
  ServerContainer: TServerContainer;

implementation

uses
  XData.Sys.Exceptions, uServerUtils;

{%CLASSGROUP 'Vcl.Controls.TControl'}

{$R *.dfm}

procedure TServerContainer.DataModuleCreate(Sender: TObject);
begin
  RegisterTMSLogger;
  TMSDefaultLogger.RegisterOutputHandlerClass(
    TTMSLoggerTextOutputHandler, ['XData.log']);
end;

end.

